=== debian/changelog ===
rbdoom3bfg (1.4.0+dfsg-8) unstable; urgency=medium

  * (really) fix build against ffmpeg 8.0 (Closes: #1122888)

 -- Sébastien Noel <sebastien@twolife.be>  Sat, 13 Dec 2025 20:54:07 +0100
