=== debian/control ===
Source: rbdoom3bfg
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Sébastien Noel <sebastien@twolife.be>
Build-Depends: cmake,
               debhelper-compat (= 13),
               libavcodec-dev,
               libavformat-dev,
               libavutil-dev,
               libglew-dev,
               libimgui-dev,
               libjpeg-dev,
               libopenal-dev,
               libpng-dev,
               libsdl2-dev,
               libswscale-dev,
               rapidjson-dev (>= 1.1.0+dfsg2-7.3~),
               zlib1g-dev
Standards-Version: 4.7.2
Homepage: https://github.com/RobertBeckebans/RBDOOM-3-BFG
Vcs-Browser: https://salsa.debian.org/games-team/rbdoom3bfg
Vcs-Git: https://salsa.debian.org/games-team/rbdoom3bfg.git

Package: rbdoom3bfg
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Recommends: game-data-packager-runtime (>= 81~)
Suggests: doom3bfg-data | game-data-packager
Description: Doom3 BFG edition game engine
 RBDoom3BFG 3 is a Doom 3 BFG GPL source modification. The goal of RBDoom3BFG 3
 is to bring Doom 3 BFG with the help of SDL to all suitable platforms. Bugs
 present in the original DOOM 3 will be fixed (when identified) without altering
 the original game-play.
 .
 Note, to play the original game, you'll need a copy of the game data.
 .
 The package can also be used with free map data, like the demomap from
 OpenTechBFG.
