=== debian/watch ===
Version: 5
Template: Github
Owner: RobertBeckebans
Project: RBDOOM-3-BFG
Repack: yes
Repacksuffix: +dfsg
Dversion-Mangle: auto
